/**
   Compare this with 2-thread-vs-function.c
*/
public class Thread_vs_function_2_ver1
{
   public static void main(String[] args)
   {
      Function1 f1 = new Function1();
      Function2 f2 = new Function2();
      //        f1 = null;   // What affect would this line have?

      Thread t1 = new Thread( f1 );
      Thread t2 = new Thread( f2 );

      t1.start();
      t2.start();
    //t2.start();   // Can we start another thread in t2?

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.err.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}


class Function1 implements Runnable
{
   public void run()
   {
      System.err.print("hello ");
      try
      {
         Thread.sleep(1000);
      }
      catch (InterruptedException e){e.getMessage();}
      System.err.println("from thread " + Thread.currentThread().getId() + "!\n");
      return;
   }
}


class Function2 implements Runnable
{
   public void run()
   {
      System.err.print("HELLO ");
      try
      {
         Thread.sleep(1000);
      }
      catch (InterruptedException e){e.getMessage();}
      System.err.println("FROM THREAD " + Thread.currentThread().getId() + "!\n");
      return;
   }
}
