/**
   We can mix up the two patterns for creating a thread
   and give a Thread object two nontrivial run() methods!
*/
public class Thread_vs_function_2_ver2_experiment
{
   public static void main(String[] args)
   {
      Thread t1 = new Thread1(); // Use our explicit default constructor.

      t1.start(); // Which run() method gets called?

      try
      {
         t1.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.err.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}


class Thread1 extends Thread
{
   // Explicitly give this class a default constructor.
   public Thread1()
   {
      // Give this object a non-null Runnable reference.
      super( new Functor() );
   }


   public void run() // override run() in Thread
   {
     super.run(); // force the running of the Runnable run() method

      System.err.print("hello ");
      try
      {
         Thread.sleep(1000);
      }
      catch (InterruptedException e){e.getMessage();}
      System.err.println("from this thread function! (in thread "
                          + this.getId() + ")\n");
      return;
   }
}


class Functor implements Runnable
{
   public void run() // implements Runnable
   {
      System.err.print("HELLO ");
      try
      {
         Thread.sleep(1000);
      }
      catch (InterruptedException e){e.getMessage();}
      System.err.println("FROM THE OTHER THREAD FUNTION! (in thread "
                          + Thread.currentThread().getId() + ")\n");
      return;
   }
}
