/**
   Compare this with 2-thread-vs-function.c
*/
public class Thread_vs_function_2_ver3
{
   public static void main(String[] args)
   {
      // Use an anonymous inner class that implements Runnable.
      Thread t1 = new Thread(
         new Runnable(){
            public void run()
            {
               System.err.print("hello ");
               try
               {
                  Thread.sleep(1000);
               }
               catch (InterruptedException e){e.getMessage();}
               System.err.println("from thread " + Thread.currentThread().getId() + "!\n");
               return;
            }});

      // Use an anonymous inner class that implements Runnable
      Thread t2 = new Thread(
         new Runnable(){
            public void run()
            {
               System.err.print("HELLO ");
               try
               {
                  Thread.sleep(1000);
               }
               catch (InterruptedException e){e.getMessage();}
               System.err.println("FROM THREAD " + Thread.currentThread().getId() + "!\n");
               return;
            }});

      t1.start();
      t2.start();

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.err.println("All done (thread id " + Thread.currentThread().getId() + ").");
      return;
   }
}
