/**
   Compare this with 2-thread-vs-function.c
*/
public class Thread_vs_function_2_with_args_ver3
{
   public static void main(String[] args)
   {
      // Use an anonymous inner class that implements Runnable.
      Thread t1 = new Thread(
         new Runnable(){
            public int x = 0; // create "input" values for a thread
            public int y = 0;
            public void run() // implementing Runnable
            {
               System.err.print("hello ");
               try
               {
                  Thread.sleep(1000);
               }
               catch (InterruptedException e){e.getMessage();}
               System.err.println("from thread " + Thread.currentThread().getId() + "!\n");
               x = x+y; // create an "ouput" value for a thread
               return;
            }});

      // Use an anonymous inner class that implements Runnable
      Thread t2 = new Thread(
         new Runnable(){
            public int x = 0; // create "input" values for a thread
            public int y = 0;
            public void run() // implementing Runnable
            {
               System.err.print("HELLO ");
               try
               {
                  Thread.sleep(1000);
               }
               catch (InterruptedException e){e.getMessage();}
               System.err.println("FROM THREAD " + Thread.currentThread().getId() + "!\n");
               x = x+y;  // create an "ouput" value for a thread
               return;
            }});

      // find a way to set the "parameters" in the
      // anonymous Runnable objects belonging to t1 and t2

      t1.start();
      t2.start();

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      // find a way to get the "parameters" in the
      // anonymous Runnable objects belonging to t1 and t2

      System.err.println("All done.");
      return;
   }
}
