/**
   Compare this with 2-thread-vs-function.c
*/
public class Thread_vs_function_2_with_args_ver4
{
   public static void main(String[] args)
   {
      // Use an anonymous inner class that implements Runnable.
      Thread t1 = new Thread(){
            public int x = 0;  // create "input" values for a thread
            public int y = 0;
            public void run()
            {
               System.err.print("hello ");
               try
               {
                  Thread.sleep(1000);
               }
               catch (InterruptedException e){e.getMessage();}
               System.err.println("x= " + x + ": from thread " + this.getId() + "!\n");
               x = 100*x;  // create an "ouput" value for a thread
               return;
            }};

      // Use an anonymous inner class that implements Runnable
      Thread t2 = new Thread(){
            public int x = 0;  // create "input" values for a thread
            public int y = 0;
            public void run()  // overriding run() from Thread
            {
               System.err.print("HELLO ");
               try
               {
                  Thread.sleep(1000);
               }
               catch (InterruptedException e){e.getMessage();}
               System.err.println("x = " + x + ": FROM THREAD " + this.getId() + "!\n");
               x = 200*x;  // create an "ouput" value for a thread
               return;
            }};

      // find a way to set the "parameters" in the
      // anonymous Thread objects referred to by t1 and t2

      // NOTE: Comment out the next two lines and compile this program,
      // then uncomment out the next two lines and recompile this program,
      // and then run this program.
      ((Thread_vs_function_2_with_args_ver4$1)t1).x = 10;
      ((Thread_vs_function_2_with_args_ver4$2)t2).x = 200;
      //((Thread_vs_function_2_with_args_ver4$1)t1).y = 20;
      //((Thread_vs_function_2_with_args_ver4$2)t2).y = 400;

      t1.start();
      t2.start();

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      // find a way to get the "parameters" in the
      // anonymous Thread objects referred to by t1 and t2

      //System.out.println( ((Thread_vs_function_2_with_args_ver4$1)t1).x );
      //System.out.println( ((Thread_vs_function_2_with_args_ver4$2)t2).x );

      System.err.println("All done.");
      return;
   }
}
