/**
   Compare this with 5-thread-vs-function-w-args.c
*/
public class Thread_vs_function_5_with_arg
{
   public static void main(String[] args)
   {
      Function1 f1 = new Function1(101);
      Function2 f2 = new Function2(202);

      Thread t1 = new Thread( f1 );
      Thread t2 = new Thread( f2 );

      t1.start();
      t2.start();

      try
      {
         t1.join();
         t2.join();
      }
      catch (InterruptedException e){e.getMessage();}

      System.err.println("All done.");
      return;
   }
}


class Function1 implements Runnable
{
   public int arg;

   Function1 (int arg)
   {
      this.arg = arg;
   }

   public void run()
   {
      System.err.print("hello ");
      try
      {
         Thread.sleep(1000);
      }
      catch (InterruptedException e){e.getMessage();}
      System.err.println("from thread 1 with argument " + arg + "!\n");
      return;
   }
}


class Function2 implements Runnable
{
   public int arg;

   Function2 (int arg)
   {
      this.arg = arg;
   }

   public void run()
   {
      System.err.print("HELLO ");
      try
      {
         Thread.sleep(1000);
      }
      catch (InterruptedException e){e.getMessage();}
      System.err.println("FROM THREAD 2 WITH ARGUMENT " + arg + "!\n");
      return;
   }
}
